!  Post3D
!
!   DESCRIPTION
!   Phase shift and split step migration plus interpolation
!
!   USAGE
!     Ph3D_MP < in.H > out.H par=par.P apply_split_step=
!
!%

program Pre3D_salt_ssf

  use sep
  use gendown3d_mod

  use param_pre3d
  use Pre3D_salt_ssf_types
  use Pre3D_salt_ssf_mod

  implicit none




  type (Pre3D_salt_ssf_param_type) Pre3D_salt_ssf_par
  logical adj,add
  logical datuming,prestack
  integer stat,getch
  external getch
  character(len=128) tag_data,tag_mod

  call initpar()
  call sep_begin_prog()

  tag_data='Image'
  tag_mod='Data'

  call from_param('datuming',datuming,.false.)
  call from_param('add',add,.false.)
  call from_param('adj',adj,.false.)


  if(datuming) then
    tag_data='Down_data'
    tag_mod='Data'

    call param_Pre3D_salt_ssf(Pre3D_salt_ssf_par)
    call init_Pre3D_salt_ssf_par(Pre3D_salt_ssf_par)
    call gendown3d_init(verb=.false.,init_down_oper=Pre3D_salt_ssf_init)

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  Pre3D_salt_ssf_down_oper,Pre3D_salt_ssf_scatter_oper)
  !}
  else
  !{

    tag_data='Image'
    tag_mod='Data'

    call param_Pre3D_salt_ssf(Pre3D_salt_ssf_par)
    call init_Pre3D_salt_ssf_par(Pre3D_salt_ssf_par)
    call gendown3d_init(verb=.false.,init_down_oper=Pre3D_salt_ssf_init)

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  Pre3D_salt_ssf_down_oper,Pre3D_salt_ssf_scatter_oper)
  !}
  end if


   call sep_end_prog()
  stop	
end program Pre3D_salt_ssf
